// MPRtlBluetoothSample.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <math.h>
#include <stdarg.h>
#include <windows.h>
#include <shellapi.h>

#define ESCAPE 27
//  Test 
#define HIT_ADDRESS_SET 0x0000009e8b33
#define PKTTYPE_SET		BT_PKT_1DH1
#define PKTHEADER_SET   0x1234
#define WHITENCOEFF_SET		0
#define PKTCOUNT_SET		100
#define PAYLOADTYPE_SET  BT_PAYLOAD_TYPE_PRBS9


#define _RTK_INTRFACE_MODE_
#define AUTO_DOWN_LOAD_PATCH_CODE


#ifdef __cplusplus 
extern "C" { 
#endif

#include "RtlBluetoothMP.h"
#include "bt_mp_dll_build.h"
#include "bt_user_func.h"
#include "Vendor_Interface\usbio.h"
#ifdef __cplusplus 
}
#endif


#ifdef DBG_ON
        static void DBGPRINTF(char *prompt, ...)
        {
        char buf[2048];
        va_list argptr;
        int cnt;

        va_start(argptr, prompt);
        cnt = vsprintf(buf, prompt, argptr);
        OutputDebugString(buf);
        va_end(argptr);
        return ;
        }
  
#else
	#define DBGPRINTF printf
#endif

//=========================  define ==========================================
//#define AUTO_DOWN_LOAD_PATCH_CODE
static DWORD t1,t2,tt;

//dll object
BASE_BTMPDLLObject mBaseDLLObject;
BASE_BTMPDLLObject *pBaseDLLObject=NULL;

//bt para , report , info
BT_PARAMETER mBT_PARAMETER;
BT_DEVICE_REPORT mBT_DEVICE_REPORT;
BT_CHIPINFO mBT_CHIPINFO;

//module
static BASE_INTERFACE_MODULE	*pBaseInterface=NULL;
BASE_INTERFACE_MODULE BaseInterfaceModuleMemory;
static BASE_BTMPDLL_MODULE *pBluetoothModule=NULL ;
BASE_BTMPDLL_MODULE BluetoothModuleMemory;


static int API_bt_GetChipInfo()
{

	BT_DEVICE_REPORT	*pBtReport=&mBT_DEVICE_REPORT;
	BT_CHIPINFO	        *pBTInfo=NULL;

	DBGPRINTF(">>API_bt_GetChipInfo\n");
	
	if (pBluetoothModule == NULL)
	{
		DBGPRINTF(">>BluetoothModule is NULL...!!\n");
		goto error;
	}

	if (pBluetoothModule->ActionReport(pBluetoothModule,REPORT_CHIP,pBtReport) !=0)
	{
		DBGPRINTF(">>Get Chip Info is Fail...!!\n");
		goto error;
	}
	pBTInfo=  pBtReport->pBTInfo;
	memcpy(&mBT_CHIPINFO,pBTInfo,sizeof(BT_CHIPINFO));   
	DBGPRINTF(">>ChipType=(%x)\n",pBTInfo->ChipType); 
	DBGPRINTF(">>HCI_SubVersion=0x%x\n",pBTInfo->HCI_SubVersion); 
	DBGPRINTF(">>HCI_Version=0x%x\n",pBTInfo->HCI_Version);
	DBGPRINTF(">>LMP_SubVersion=0x%x\n",pBTInfo->LMP_SubVersion);
	DBGPRINTF(">>LMP_Version=0x%x\n",pBTInfo->LMP_Version); 
	DBGPRINTF(">>Version=%.2x\n",pBTInfo->Version+9); 
	DBGPRINTF(">>Is_After_PatchCode=%d\n",pBTInfo->Is_After_PatchCode);

	DBGPRINTF("<<API_bt_GetChipInfo\n");
	
	return BT_FUNCTION_SUCCESS;

error:

	DBGPRINTF("<<API_bt_GetChipInfo : ERROR\n");
	
	return FUNCTION_ERROR;

}

static int API_bt_Download_PatchCode()
{
	BT_CHIPINFO	        *pBTInfo=&mBT_CHIPINFO;
	char *buffer = NULL;
	int lSize=0;
	int szLen=0;
	FILE *DataFile=NULL;

	char tmp_FileName[][50]={
			{"BTPatchCode\\patch_rtl8723a.bin"}, // 0
			{"BTPatchCode\\patch_rtl8723b.bin"}, // 1
			{"BTPatchCode\\patch_rtl8821a.bin"}, // 2
			{"BTPatchCode\\patch_rtl8761a.bin"}, // 3
			{"BTPatchCode\\patch_rtl8703a.bin"}, // 4
			{"BTPatchCode\\patch_rtl8763a.bin"}, // 5
			{"BTPatchCode\\patch_rtl8703b.bin"}, // 6
			{"BTPatchCode\\patch_rtl8723c.bin"}, // 7
			{"BTPatchCode\\patch_rtl8822b.bin"}, // 8
	};


	DBGPRINTF(">>API_bt_Download_PatchCode\n");
	
	if (pBluetoothModule == NULL)
	{
		DBGPRINTF(">>BluetoothModule is NULL...!!\n");
		goto error;
	}
	if (API_bt_GetChipInfo() !=0 )
	{
			DBGPRINTF(">>Get Chip info error!!");
			goto error;
	}
	if(pBTInfo->Is_After_PatchCode)
	{
		DBGPRINTF(">>Skip patch code !!\n");
		return BT_FUNCTION_SUCCESS;
	}


	DataFile = fopen(tmp_FileName[pBTInfo->ChipType], "r+b");
 	if (DataFile == NULL)
	{
		DBGPRINTF(">>Error File patch = %s..\n",tmp_FileName[pBTInfo->ChipType]);
		goto error;
	}	

	fseek(DataFile, 0, SEEK_END);
	lSize = ftell(DataFile);

	fseek(DataFile, 0, 0);

	buffer = (char *)malloc(lSize);
	if (!buffer)
	{
		DBGPRINTF(">>allocate File patch error = %s..\n",tmp_FileName[pBTInfo->ChipType]);
		goto error;
	}

	if (fread(buffer,1,lSize,DataFile) == 0)
	{
		goto error;
	}
	if (pBluetoothModule->DownloadPatchCode(pBluetoothModule,buffer,lSize,1) != BT_FUNCTION_SUCCESS)
	{
		DBGPRINTF(">>download patch code Faild!!..\n");
		goto error;
	}
	else
		DBGPRINTF(">>download patch code Success!!..\n");


	if (API_bt_GetChipInfo() !=0 )
	{
		DBGPRINTF(">>Get Chip info error!!");
		goto error;
	}


	DBGPRINTF("<<API_bt_Download_PatchCode\n");

	if (buffer)
		free(buffer);

	if (DataFile != NULL)
		fclose(DataFile);
	
	return BT_FUNCTION_SUCCESS;

error:

	DBGPRINTF("<<API_bt_Download_PatchCode : ERROR\n");	
	if (buffer)
		free(buffer);

	if (DataFile != NULL)
		fclose(DataFile);
	
	return FUNCTION_ERROR;	

}

static int API_bt_SetDefaultTxDACTable()
{
	BT_PARAMETER 	*pParam=&mBT_PARAMETER;

	if (pBluetoothModule == NULL)
	{
		goto error;
	}

	pParam->ParameterIndex= SET_DEFAULT_TX_DAC_TABLE;
	pBluetoothModule->UpDataParameter(pBluetoothModule,pParam);
	if (pBluetoothModule->ActionControlExcute(pBluetoothModule)!=0)
	{
		goto error;
	}

	DBGPRINTF("SetDefaultTxDACTable()\n");
	
	return BT_FUNCTION_SUCCESS;

error:

	DBGPRINTF("SetDefaultTxDACTable() : ERROR\n");
	return FUNCTION_ERROR;

}



static int API_bt_SetdefaultPowerTable()
{
	BT_PARAMETER 	*pParam=&mBT_PARAMETER;

	if (pBluetoothModule == NULL)
	{
		goto error;
	}

	pParam->ParameterIndex= SET_DEFAULT_TX_GAIN_TABLE;
	pBluetoothModule->UpDataParameter(pBluetoothModule,pParam);	
	if (pBluetoothModule->ActionControlExcute(pBluetoothModule)!=0)
	{
		goto error;
	}

	DBGPRINTF("SetdefaultPowerTable()\n");
	
	return BT_FUNCTION_SUCCESS;

error:

	DBGPRINTF("SetdefaultPowerTable() : ERROR\n");
	
	return FUNCTION_ERROR;
	
}

void BT_PktTx(BASE_BTMPDLL_MODULE  *pBtModule)
{
	BT_PARAMETER	     mBaseBtParamMemory;
	BT_CHIPINFO			 mBaseBTInfoMemory;
	BT_DEVICE_REPORT	 mBaseModuleBtReportMemory;

	BT_PARAMETER		*pBtParam =&mBaseBtParamMemory;
	BT_DEVICE_REPORT	*pBtReport=&mBaseModuleBtReportMemory;
	BT_CHIPINFO	*pBTInfo=&mBaseBTInfoMemory;

	DWORD                   t1,t2,tt;
	char ch=0;
	int rtn=0;
	int Channel=0;
	int pkt_count=0;
	printf("\nPlease input channel =");
	scanf("%d",&Channel);
	printf("\nPlease input PKT Count=");
	scanf("%d",&pkt_count);

	memset(pBtReport,0,sizeof(BT_DEVICE_REPORT));
	
	/*Setting Parameter*/
    	pBtParam->mChannelNumber=(unsigned char)Channel&0xFF;
    	pBtParam->mPacketType=PKTTYPE_SET;
 /*//////////////////////////////////////////////
//BT Default Power Index
//Name                   USB/PCIE       UART  
//RTK_BT_CHIP_ID_RTL8723A  6         6
//RTK_BT_CHIP_ID_RTL8723B  5         4
//RTK_BT_CHIP_ID_RTL8821A  6         6
//RTK_BT_CHIP_ID_RTL8761A  6         6
//RTK_BT_CHIP_ID_RTL8703A  6         6
//RTK_BT_CHIP_ID_RTL8763A  6         6
//RTK_BT_CHIP_ID_RTL8703B  6         6
//RTK_BT_CHIP_ID_RTL8723C  6         6
//RTK_BT_CHIP_ID_RTL8822B  6         6
//////////////////////////////////////////////*/   	
    	
    	pBtParam->mTxGainIndex=0x6;
    	pBtParam->mTxPacketCount=pkt_count;
    	pBtParam->mPayloadType=PAYLOADTYPE_SET;
    	pBtParam->mTxDAC=0x13;
    	pBtParam->mWhiteningCoeffValue=WHITENCOEFF_SET;
	pBtParam->mPacketHeader= PKTHEADER_SET;
	pBtParam->mHitTarget=HIT_ADDRESS_SET;

  	pBtParam->ParameterIndex=PACKET_TX_START;
    	printf("ActionControlExcute(%d)!!\n",pBtParam->ParameterIndex);
	pBtModule->UpDataParameter(pBtModule,pBtParam);
	
	/*Excute the Parameter*/
	if (pBtModule->ActionControlExcute(pBtModule) != BT_FUNCTION_SUCCESS)
	{
		printf("Excute Pkt-Tx begin Fail!!\n");
		goto exit;
	}
	else
		printf("Excute Pkt-Tx begin Success!!\n");


	t1=GetTickCount();
	tt=0;
	printf("please ESC any is exit ...\n");

	while(1)
	{ 
		if ( kbhit())
		{
			ch=getch();
			if (ch == ESCAPE )
				break;
		}
		t2=GetTickCount();
		tt=labs(t2-t1);
		/*Report TX/RX info */
		pBtModule->ActionReport(pBtModule,REPORT_PKT_TX,pBtReport);

		printf("Excute Pkt-Tx Updata!!Tx Bits = %d Tx Count=%d (%d)\n"
			,pBtReport->TotalTXBits
			,pBtReport->TotalTxCounts
			,tt);
	
		Sleep(1000);

	}
	//Stop

	pBtParam->ParameterIndex=PACKET_TX_STOP;
	pBtModule->UpDataParameter(pBtModule,pBtParam);
	if (pBtModule->ActionControlExcute(pBtModule) != BT_FUNCTION_SUCCESS)
	{
		printf("Excute Pkt-Tx Stop  Error!!\n");
	}
	else
		printf("Excute Pkt-Tx Stop  Success!!\n"); 

exit:
	return ;


}
void BT_PktRx(BASE_BTMPDLL_MODULE  *pBtModule)
{

	BT_PARAMETER	     mBaseBtParamMemory;
	BT_CHIPINFO			 mBaseBTInfoMemory;
	BT_DEVICE_REPORT	 mBaseModuleBtReportMemory;

	BT_PARAMETER		*pBtParam =&mBaseBtParamMemory;
	BT_DEVICE_REPORT	*pBtReport=&mBaseModuleBtReportMemory;
	BT_CHIPINFO	*pBTInfo=&mBaseBTInfoMemory;
	DWORD                   t1,t2,tt; 
	float ber=0;
	float all_bits=0;
	int rtn=0;
	char ch=0;
	int Channel=0;
	printf("\nPlease input channel =");
	scanf("%d",&Channel);
	memset(pBtReport,0,sizeof(BT_DEVICE_REPORT));
	
	/*Setting Parameter*/
    	pBtParam->mChannelNumber=(unsigned char)Channel&0xFF;
    	pBtParam->mPacketType=PKTTYPE_SET;

    	pBtParam->mTxGainIndex=0x07;
    	pBtParam->mTxPacketCount=0;
	pBtParam->mPayloadType=PAYLOADTYPE_SET; //BT_PAYLOAD_TYPE_ALL0
    	pBtParam->mTxDAC=0x13;
    	pBtParam->mWhiteningCoeffValue=WHITENCOEFF_SET;
	pBtParam->mPacketHeader=PKTHEADER_SET;
	pBtParam->mHitTarget=HIT_ADDRESS_SET;


	pBtParam->ParameterIndex=PACKET_RX_START;
	printf("ActionControlExcute(%d)!!\n",pBtParam->ParameterIndex);
	pBtModule->UpDataParameter(pBtModule,pBtParam);
	/*Excute the Parameter*/
	if (pBtModule->ActionControlExcute(pBtModule) != BT_FUNCTION_SUCCESS)
	{
		printf("Excute Pkt-Rx begin Fail!!\n");
		goto exit;
	}
	else
		printf("Excute Pkt-Rx begin Success!!\n");


	t1=GetTickCount();
	tt=0;

	pBtParam->ParameterIndex =REPORT_CLEAR;
	pBtModule->UpDataParameter(pBtModule,pBtParam);
	if (pBtModule->ActionControlExcute(pBtModule) != BT_FUNCTION_SUCCESS)
	{
		printf("Excute Reset RX Report Fail!!\n");
	}
	else
		printf("Excute Reset RX Report Success!!\n");
     
	 printf("Please click ESC key pressed to exit...\n");

	while(1)
	{ 

		if ( kbhit())
		{
			ch=getch();
			if (ch == ESCAPE )
	 		break;
		}
		t2=GetTickCount();
		tt=labs(t2-t1);

		/*Report TX/RX info */
		pBtModule->ActionReport(pBtModule,REPORT_RKT_RX,pBtReport);
		ber=0;
		all_bits=(float)(pBtReport->TotalRxErrorBits+pBtReport->TotalRXBits);

		if ((pBtReport->TotalRXBits ==0) || (pBtReport->TotalRxCounts==0))
			ber=1;
		else
			ber=(float)  ((float)(pBtReport->TotalRxErrorBits))/  ((float)(all_bits));
       	
			printf("Pkt-Rx [R1]:RX_Recv_PktCnt= %d Rx_PktCnt=%d Ber=%f\n",pBtReport->RXRecvPktCnts,pBtReport->TotalRxCounts,ber);   
			printf("Pkt-Rx [R2]:Total Rx_Bits = %d Total Rx_error_Bits=%d Total RX_BER=%f\n",pBtReport->TotalRXBits,pBtReport->TotalRxErrorBits,pBtReport->ber);
			printf("Pkt-Rx [R3]:RSSI=%d(%d)  \n",pBtReport->RxRssi,tt);
			Sleep(1000);

	}
	//Stop
	pBtParam->ParameterIndex=PACKET_RX_STOP;
	pBtModule->UpDataParameter(pBtModule,pBtParam);
        if (pBtModule->ActionControlExcute(pBtModule) != BT_FUNCTION_SUCCESS)
        {
                printf("Excute Pkt-Rx Stop  Error!!\n");
        }
        else
                printf("Excute Pkt-Rx Stop  Success!!\n"); 
exit:
	return ;


}
void BT_ConTx(BASE_BTMPDLL_MODULE  *pBtModule)
{
	BT_PARAMETER	     mBaseBtParamMemory;
	BT_CHIPINFO			 mBaseBTInfoMemory;
	BT_DEVICE_REPORT	 mBaseModuleBtReportMemory;

	BT_PARAMETER		*pBtParam =&mBaseBtParamMemory;
	BT_DEVICE_REPORT	*pBtReport=&mBaseModuleBtReportMemory;
	BT_CHIPINFO	*pBTInfo=&mBaseBTInfoMemory;

	char ch=0;

	DWORD                t1,t2,tt; 
	int Channel=0;
	printf("\nPlease input channel =");
	scanf("%d",&Channel);
	memset(pBtReport,0,sizeof(BT_DEVICE_REPORT));
	
	/*Setting Parameter*/
    	pBtParam->mChannelNumber=(unsigned char)Channel&0xFF;

    	pBtParam->mPacketType=BT_PKT_3DH5;
    	pBtParam->mTxGainIndex=0xFF;
    	pBtParam->mTxGainValue=0xA9;
    	pBtParam->mTxPacketCount=0;
    	pBtParam->mPayloadType=BT_PAYLOAD_TYPE_ALL0;
    	pBtParam->mTxDAC=0x13;
    	pBtParam->mWhiteningCoeffValue=0x80; 
	pBtParam->mPacketHeader= 0x031803;
	pBtParam->mHitTarget=0x0000009e8b33;

  	pBtParam->ParameterIndex=CONTINUE_TX_START;
  	
    	printf("ActionControlExcute(%d)!!\n",pBtParam->ParameterIndex);
	pBtModule->UpDataParameter(pBtModule,pBtParam);
	/*Excute the Parameter*/
	if (pBtModule->ActionControlExcute(pBtModule) != BT_FUNCTION_SUCCESS)
	{
		printf("Excute Con-Tx begin Fail!!\n");
		goto exit;
	}
	else
		printf("Excute Con-Tx begin Success!!\n");

	t1=GetTickCount();
	tt=0;

	while(1)
        { 
		t2=GetTickCount();
		tt=labs(t2-t1);

		if ( kbhit())
		{
			ch=getch();
			if (ch == ESCAPE )
	 			break;
		}
		/*Report TX/RX info */
		pBtModule->ActionReport(pBtModule,REPORT_CON_TX,pBtReport);

		printf("Excute Con-Tx Updata!!Tx Bits = %d Tx Count=%d (%d)\n",pBtReport->TotalTXBits
										,pBtReport->TotalTxCounts,tt);
		Sleep(1000);

	}
	//Stop
	pBtParam->ParameterIndex=CONTINUE_TX_STOP;
	pBtModule->UpDataParameter(pBtModule,pBtParam);
	if (pBtModule->ActionControlExcute(pBtModule) != BT_FUNCTION_SUCCESS)
	{
                printf("Excute Con-Tx Stop  Error!!\n");
	}
	else
                printf("Excute Con-Tx Stop  Success!!\n"); 
exit:
	return ;
}

void BT_HCIRST(BASE_BTMPDLL_MODULE  *pBtModule)
{
	BT_PARAMETER	     mBaseBtParamMemory;
	BT_CHIPINFO			 mBaseBTInfoMemory;
	BT_DEVICE_REPORT	 mBaseModuleBtReportMemory;

	BT_PARAMETER		*pBtParam =&mBaseBtParamMemory;
	BT_DEVICE_REPORT	*pBtReport=&mBaseModuleBtReportMemory;
	BT_CHIPINFO	*pBTInfo=&mBaseBTInfoMemory;


	/*Setting Parameter*/
	pBtParam->ParameterIndex=HCI_RESET;

	pBtModule->UpDataParameter(pBtModule,pBtParam);

	if (pBtModule->ActionControlExcute(pBtModule) != BT_FUNCTION_SUCCESS)
	{
		printf("Excute HCI Reset Fail!!\n");
		goto exit;
	}
	else
		printf("Excute HCI Reset Success!!\n");
exit:
	return ;
}



void BT_ReadBDAddr(BASE_BTMPDLL_MODULE  *pBtModule)
{
	BT_PARAMETER	     mBaseBtParamMemory;
	BT_CHIPINFO			 mBaseBTInfoMemory;
	BT_DEVICE_REPORT	 mBaseModuleBtReportMemory;

	BT_PARAMETER		*pBtParam =&mBaseBtParamMemory;
	BT_DEVICE_REPORT	*pBtReport=&mBaseModuleBtReportMemory;
	BT_CHIPINFO	*pBTInfo=&mBaseBTInfoMemory;
	
	unsigned char *pPGRawData;
	unsigned char *pReportData;	

	pBtParam->ParameterIndex = READ_EFUSE_DATA;
	pPGRawData = pBtParam->mPGRawData;
	pReportData = pBtReport->ReportData;

	pPGRawData[0] = 0x01; // BT Efuse
	pPGRawData[1] = 0x3c;
	pPGRawData[2] = 0x00;
	pPGRawData[3] = 0x06;
	pBtModule->UpDataParameter(pBtModule,pBtParam);
	if (pBtModule->ActionControlExcute(pBtModule) !=0)
	{
		printf("Excute BT_ReadBDAddr Fail!!\n");
	}
	else
	{
		memset(pReportData,0x00, MAX_USERAWDATA_SIZE);
		pBtModule->ActionReport(pBtModule, REPORT_LOGICAL_EFUSE, pBtReport);
		printf("BT_ReadBDAddr = 0x%.2x%.2x%.2x%.2x%.2x%.2x\n", pReportData[9], pReportData[8], pReportData[7], pReportData[6], pReportData[5], pReportData[4]);
	}

	return ;
}


void BT_WriteBDAddr(BASE_BTMPDLL_MODULE  *pBtModule)
{
	BT_PARAMETER	     mBaseBtParamMemory;
	BT_CHIPINFO			 mBaseBTInfoMemory;
	BT_DEVICE_REPORT	 mBaseModuleBtReportMemory;


	BT_PARAMETER		*pBtParam =&mBaseBtParamMemory;
	BT_DEVICE_REPORT	*pBtReport=&mBaseModuleBtReportMemory;
	BT_CHIPINFO	*pBTInfo=&mBaseBTInfoMemory;

	printf("\nWriteBDAddr= 0x00E023345678\n");

	pBtParam->mPGRawData[0] = 0x01;  // BT Efuse
	pBtParam->mPGRawData[1] = 0x3c;  // offset low byte
	pBtParam->mPGRawData[2] = 0x00;  // offset high byte
	pBtParam->mPGRawData[3] = 0x06;  // len
	pBtParam->mPGRawData[4] = 0x78;  //BD ADDR data
	pBtParam->mPGRawData[5] = 0x56;  //BD ADDR data
	pBtParam->mPGRawData[6] = 0x34;  //BD ADDR data
	pBtParam->mPGRawData[7] = 0x23;  //BD ADDR data
	pBtParam->mPGRawData[8] = 0xe0;  //BD ADDR data
	pBtParam->mPGRawData[9] = 0x00; //BD ADDR data
	pBtParam->ParameterIndex = WRITE_EFUSE_DATA;
	pBtModule->UpDataParameter(pBtModule,pBtParam);
	if(pBtModule->ActionControlExcute(pBtModule)!=0)
	{
		printf("Excute BT_WriteBDAddr Fail!!\n");
	}
	else
	{
		printf("Excute BT_WriteBDAddr Success!!\n");

	}

	return ;
}





void BT_CHIP(BASE_BTMPDLL_MODULE  *pBtModule)
{
	char *buffer = NULL;
	int lSize=0;
	FILE *DataFile=NULL;
	char  cz=0;
	char tmp_FileName[][50]={
			{"BTPatchCode\\patch_rtl8723a.bin"}, // 0
			{"BTPatchCode\\patch_rtl8723b.bin"}, // 1
			{"BTPatchCode\\patch_rtl8821a.bin"}, // 2
			{"BTPatchCode\\patch_rtl8761a.bin"}, // 3
			{"BTPatchCode\\patch_rtl8703a.bin"}, // 4
			{"BTPatchCode\\patch_rtl8763a.bin"}, // 5
			{"BTPatchCode\\patch_rtl8703b.bin"}, // 6
			{"BTPatchCode\\patch_rtl8723c.bin"}, // 7
			{"BTPatchCode\\patch_rtl8822b.bin"}, // 8
	};

	BT_PARAMETER	     mBaseBtParamMemory;
	BT_CHIPINFO			 mBaseBTInfoMemory;
	BT_DEVICE_REPORT	 mBaseModuleBtReportMemory;

	BT_PARAMETER		*pBtParam =&mBaseBtParamMemory;
	BT_DEVICE_REPORT	*pBtReport=&mBaseModuleBtReportMemory;
	BT_CHIPINFO	*pBTInfo=&mBaseBTInfoMemory;




	pBtModule->ActionReport(pBtModule,REPORT_CHIP,pBtReport);

	printf("ChipType=(%x)\n",pBtReport->pBTInfo->ChipType);
	printf("HCI_SubVersion=0x%x\n",pBtReport->pBTInfo->HCI_SubVersion);
	printf("HCI_Version=0x%x\n",pBtReport->pBTInfo->HCI_Version);
	printf("LMP_SubVersion=0x%x\n",pBtReport->pBTInfo->LMP_SubVersion);
	printf("LMP_Version=0x%x\n",pBtReport->pBTInfo->LMP_Version);
	printf("Version=%.2x\n",pBtReport->pBTInfo->Version+9);
	printf("Is_After_PatchCode=%d\n",pBtReport->pBTInfo->Is_After_PatchCode);

	printf("Can you download Patch Code....(Y/N)");
	fflush(stdin);
	scanf("%c",&cz);

	if ((cz== 'y') || (cz=='Y'))
	{

			pBTInfo=pBtReport->pBTInfo;
			if ( pBTInfo->ChipType == RTK_BT_CHIP_ID_UNKNOWCHIP)
			{
						printf("Error Chip Type!!..\n");
						goto exit;
			}
			printf("open patch code = %s..\n",tmp_FileName[pBTInfo->ChipType]);
			DataFile = fopen(tmp_FileName[pBTInfo->ChipType], "r+b");
			if (DataFile == NULL)
			{
						printf("Error File patch = %s..\n",tmp_FileName);
						goto exit;
			}
			fseek(DataFile, 0, SEEK_END);
			lSize = ftell(DataFile);

			fseek(DataFile, 0, 0);

			buffer = (char *)malloc(lSize);
			if (!buffer)
			{
				printf(">>allocate File patch error = %s..\n",tmp_FileName[pBTInfo->ChipType]);
				goto exit;
			}


			if (fread(buffer,1,lSize,DataFile) == 0)
			{
						printf("read file error = %s..\n",tmp_FileName);
						goto exit;
			}
			if (pBtModule->DownloadPatchCode(pBtModule,buffer,lSize,1) != BT_FUNCTION_SUCCESS)
			{
				printf("download patch code Faild!!..\n");
				goto exit;
			}
			else	
				printf("download patch code Success!!..\n");

			pBtModule->ActionReport(pBtModule,REPORT_CHIP,pBtReport);

			printf("ChipType=(%x)\n",pBtReport->pBTInfo->ChipType);
			printf("HCI_SubVersion=0x%x\n",pBtReport->pBTInfo->HCI_SubVersion);
			printf("HCI_Version=0x%x\n",pBtReport->pBTInfo->HCI_Version);
			printf("LMP_SubVersion=0x%x\n",pBtReport->pBTInfo->LMP_SubVersion);
			printf("LMP_Version=0x%x\n",pBtReport->pBTInfo->LMP_Version);
			printf("Version=%.2x\n",pBtReport->pBTInfo->Version+9);
			printf("Is_After_PatchCode=%d\n",pBtReport->pBTInfo->Is_After_PatchCode);		

	}
exit:
	if (buffer)
		free(buffer);

	if (DataFile != NULL)
	{
		fclose(DataFile);
	}		
	return ;
}

void BT_GetBDAddr(BASE_BTMPDLL_MODULE  *pBtModule)
{
	unsigned char	pEvt[256];
	unsigned char	para[256];
	if (pBtModule->SendHciCommandWithEvent(pBtModule,0x1009,0,para,0x0e,pEvt) != 0)
	{
		printf("Get BD Addree Fail!!..\n");
	}
	printf("BD_ADDR=[0x%.2x%.2x%.2x%.2x%.2x%.2x]\n",pEvt[11],pEvt[10],pEvt[9],pEvt[8],pEvt[7],pEvt[6]);
	return ;	
}




//Led No
//0 : LED 0 is GPIO 4
//1 : LED 1 is GPIO 5 

//Led Level
//0 : output low   
//1 : output high
//2 : output Hi-Z or input
void BT_LedTest(BASE_BTMPDLL_MODULE  *pBtModule, unsigned char LedNo, unsigned char LedLevel)
{
	unsigned char pData[512];
	unsigned char pEvtBuf[512];

	pData[0] = LedNo;
	pData[1] = LedLevel;
	
	if(pBtModule == NULL)
	{
		return;
	}

	pBtModule->SendHciCommandWithEvent(pBluetoothModule, 0xfc37, 2, pData, 0x0E, pEvtBuf);

	if(pEvtBuf[5] != 0)
	{
		DBGPRINTF(">>BT_LedTest : error\n");
	}
	else
	{
		DBGPRINTF(">>BT_LedTest : successful\n");
	}

	return;
	
}

void BT_LETx_RX_Start(BASE_BTMPDLL_MODULE  *pBtModule,int TX_RX)
{
	BT_PARAMETER	     mBaseBtParamMemory;
	BT_CHIPINFO			 mBaseBTInfoMemory;
	BT_DEVICE_REPORT	 mBaseModuleBtReportMemory;

	BT_PARAMETER		*pBtParam =&mBaseBtParamMemory;
	BT_DEVICE_REPORT	*pBtReport=&mBaseModuleBtReportMemory;
	BT_CHIPINFO		*pBTInfo=&mBaseBTInfoMemory;
	unsigned long LeTest_TxGainValue = 0xa9; //By Chip Power Table

	int Channel=0;
	unsigned char LeTest_Channel = 0;
	unsigned char LeTest_DataLen = 37;
	unsigned char LeTest_PayloadType =0;
	//Pseudo-Random bit sequence 9
	//11110000
	//10101010
	//Pseudo-Random bit sequence 15
	//All 1
	//All 0
	//00001111
	//0101


	printf("\nPlease input LE Tx channel =");
	scanf("%d",&Channel);
	memset(pBtReport,0,sizeof(BT_DEVICE_REPORT));
	

	LeTest_Channel = (unsigned char)Channel&0xFF; //0~39

	pBtModule->SetMdRegMaskBits(pBluetoothModule, 0x3C, 12, 12, 0);
	pBtModule->SetBBRegMaskBits(pBluetoothModule, 0, 0x178, 15, 0, LeTest_TxGainValue);
	pBtModule->SetBBRegMaskBits(pBluetoothModule, 0, 0x17A, 15, 0, 0x382);

	/*Setting Parameter*/
    pBtParam->mChannelNumber=(unsigned char)Channel&0xFF;

	pBtParam->mParamData[0] = LeTest_DataLen;
	pBtParam->mPayloadType= LeTest_PayloadType;

	if (TX_RX)
			pBtParam->ParameterIndex= LE_RX_DUT_TEST_CMD;	
	else
  			pBtParam->ParameterIndex= LE_TX_DUT_TEST_CMD;
  	

	pBtModule->UpDataParameter(pBluetoothModule,pBtParam);

	/*Excute the Parameter*/
	if (pBtModule->ActionControlExcute(pBtModule) != BT_FUNCTION_SUCCESS)
	{
		if (TX_RX)
			printf("Excute LE-RX begin Fail!!\n");
		else
			printf("Excute LE-Tx begin Fail!!\n");
		goto exit;
	}
	else
	{
		if (TX_RX)
		printf("Excute LE-RX begin Success!! Wait LE Stop..\n");	
		else
		printf("Excute LE-Tx begin Success!! Wait LE Stop..\n");
	}
	
exit:
	return ;
}
void BT_LETx_RX_Stop(BASE_BTMPDLL_MODULE  *pBtModule)
{
	BT_PARAMETER	     mBaseBtParamMemory;
	BT_CHIPINFO			 mBaseBTInfoMemory;
	BT_DEVICE_REPORT	 mBaseModuleBtReportMemory;

	BT_PARAMETER		*pBtParam =&mBaseBtParamMemory;
	BT_DEVICE_REPORT	*pBtReport=&mBaseModuleBtReportMemory;
	BT_CHIPINFO			*pBTInfo=&mBaseBTInfoMemory;


	pBtParam->ParameterIndex= LE_DUT_TEST_END_CMD;	


	pBtModule->UpDataParameter(pBluetoothModule,pBtParam);

	/*Excute the Parameter*/
	if (pBtModule->ActionControlExcute(pBtModule) != BT_FUNCTION_SUCCESS)
	{
			printf("Excute LE-TRX Stop Fail!!\n");

	}
	else
	{

		printf("Excute LE-TRX Stop Success!!\n");	

	}
	pBluetoothModule->ActionReport(pBluetoothModule,REPORT_LE_RX, &mBT_DEVICE_REPORT);

	printf("%d",mBT_DEVICE_REPORT.TotalRxCounts);
	
	return ;
}


void BT_ReadThermalMeter(BASE_BTMPDLL_MODULE  *pBtModule, 	unsigned char *pCurrThermalValue)
{
	BT_PARAMETER	     mBaseBtParamMemory;
	BT_CHIPINFO			 mBaseBTInfoMemory;
	BT_DEVICE_REPORT	 mBaseModuleBtReportMemory;

	BT_PARAMETER		*pBtParam = &mBaseBtParamMemory;
	BT_DEVICE_REPORT	*pBtReport = &mBaseModuleBtReportMemory;
	BT_CHIPINFO			*pBTInfo = &mBaseBTInfoMemory;


	DBGPRINTF(">>++BT_ReadThermalMeter()\n"); 
	

	if(pBluetoothModule->ActionReport(pBluetoothModule,REPORT_THERMAL,pBtReport)!= BT_FUNCTION_SUCCESS)
	{
			printf("Excute Read Thermal Meter Fail!!\n");
			
			goto error;
	}

	*pCurrThermalValue =(UINT8)pBtReport->CurrThermalValue; 

	printf("Thermal Value 0x%x",*pCurrThermalValue);

	return;

	DBGPRINTF("<<--BT_ReadThermalMeter()\n");

error:
	return;
}

void BT_WriteMpParamterToEfuse(unsigned char Index, unsigned char *pData)
{
	BT_PARAMETER *pParam=&mBT_PARAMETER;
	unsigned char *pPGRawData;
	int n=0;
	int PGLen=0;
	int length=0;

	DBGPRINTF(">>++RTKBT_WriteMpParamterToEfuse()\n");

	pParam->ParameterIndex = WRITE_EFUSE_DATA;
	pPGRawData = pParam->mPGRawData;
	memset(pPGRawData,0x00,256);
	length=2;
	
	if (Index == SET_INDEX_BT_ADDR)
	{
		if ((pData[0] != 0x00) || (pData[1] != 0x00) ||(pData[2] != 0x00)
		||  (pData[3] != 0x00)|| (pData[4] != 0x00) ||(pData[5] != 0x00))
		{
			pPGRawData[0] = 0x01; // BT Efuse
			pPGRawData[1] = 0x3c; // offset low byte
			pPGRawData[2] = 0x00; // offset high byte
			pPGRawData[3] = 0x06; // len
			for (n=0; n < 6; n++) // 6-byte mac addr
				pPGRawData[n+4]= pData[n];
		}
	}
	else if (Index == SET_INDEX_TX_POWER_DAC)
	{
		pPGRawData[0] = 0x01; // BT Efuse
		pPGRawData[1] = 0x60; // offset low byte
		pPGRawData[2] = 0x01; // offset high byte
		pPGRawData[3] = 0x02; // len
		pPGRawData[4] = 0xfe; // low byte value
		pPGRawData[5] = pData[0]; // dac value
	}
	else if (Index == SET_INDEX_THERMAL)
	{
		pPGRawData[0] = 0x01; // BT Efuse
		pPGRawData[1] = 0x80; // offset low byte
		pPGRawData[2] = 0x01; // offset high byte
		pPGRawData[3] = 0x02; // len
		pPGRawData[4] = 0x00; // low byte value
		pPGRawData[5] = pData[0]; // thermal value
	}
	else if(Index == SET_INDEX_XTAL)
	{
		pPGRawData[0] = 0x01; // BT Efuse
		pPGRawData[1] = 0xe6; // offset low byte
		pPGRawData[2] = 0x01; // offset hight byte
		pPGRawData[3] = 0x01; // len
		pPGRawData[4] = pData[0] & 0x3f; // 1-byte crystal	
	}
	else if(Index == SET_INDEX_USB_VID_PID)
	{
		pPGRawData[0] = 0x02; // SYS Efuse
		pPGRawData[1] = 0x24; // offset low byte
		pPGRawData[2] = 0x00; // offset high byte
		pPGRawData[3] = 0x04; // len
		for (n = 0; n < 4; n++) // 4-byte usb vid, pid
			pPGRawData[n+4] = pData[n];	
	}		
	else
	{
		DBGPRINTF(">>No Write efuse MP Data...\n");	
		return;
	}

	pBluetoothModule->UpDataParameter(pBluetoothModule,pParam);


	if (pBluetoothModule->ActionControlExcute(pBluetoothModule) !=0)
	{
		DBGPRINTF(">>Raw Data Exec Fail...\n");
		goto exit;
	}
	else
	{
		DBGPRINTF(">>Raw Data Exec Success...\n");
	}


exit:

	DBGPRINTF(">>--RTKBT_WriteMpParamterToEfuse\n");
	
	return;
}


int main(int argc, char* argv[])
{
	int PortNumber=4;
	int Baudrate=115200;
	int item=0;
	int bflag=0;
	unsigned char pData[MAX_DATA_LEN];

	unsigned char thermal;
	   
	int HOST=1;  //0:usb ,1:uart 2:filter uart
        DBGPRINTF("============ MP RtlBluetooth DLL Sample Code ==========\n");
	//[Step 1] 
	//			>>Load RtlBluetoothMP.dll
	//			>>Build Software interface Module
	//			>>Build Software Bluetooth Module 
	// 
	pBaseDLLObject = &mBaseDLLObject;
	if (BuildBTMPDLLObject(pBaseDLLObject,NULL)!=0)
	{
		DBGPRINTF(">>Build RtlBluetoothMP.dll Module Fail!!\n");
		goto exit;
	}
	DBGPRINTF(">>Load RtlBluetoothMP.dll Module Success!!\n");

#ifdef _RTK_INTRFACE_MODE_
	DBGPRINTF("\n\n");
	DBGPRINTF("*Interface Type: 0:USB 1:UART 2:Filter Uart\n");
	DBGPRINTF("*-->Please inpunt Host Type(default is USB):");
	scanf("%d",&HOST);

	switch (HOST)
	{
	default: 
	case 0:	
		DBGPRINTF(">>Use USB Interface ...\n");
		DBGPRINTF("*Please inpunt USB Port Number:");
		scanf("%d",&PortNumber);
		break;
	case 1:
		DBGPRINTF(">>Use UART Interface ...\n");
		DBGPRINTF("*Please inpunt UART Com Port Number:");
		scanf("%d",&PortNumber);
		DBGPRINTF("*Please inpunt Baudrate:");
		scanf("%d",&Baudrate);
		break;

	case 2:
		DBGPRINTF(">>Use Filter UART Interface ...\n");
		break; 	
	}
#else
	DBGPRINTF("*==============================\n");
	DBGPRINTF("*-->Use Vendor define interface\n");
	DBGPRINTF("*==============================\n");
	DBGPRINTF(">>Use USB Interface ...\n");
	DBGPRINTF("*Please inpunt USB Port Number:");
	scanf("%d",&PortNumber);
#endif
	t1=GetTickCount();

#ifdef _RTK_INTRFACE_MODE_		

		/* Use Realtek default program
		   @ HOST : 0 is Usb  , 1 is Uart ,2 is Filter Uart ,3AND 4  is ADB HCI interface  	
		
		*/

		if(pBaseDLLObject->BTMPAPI_BuildInterfaceRTK(
			&pBaseInterface,
			&BaseInterfaceModuleMemory,
			HOST,
			PortNumber,
			(unsigned long)Baudrate,
			pData
			)!=0)
		{
			DBGPRINTF(">>Build interface Module Fail!!\n");
			goto exit;
		}
#else  
		
		//------------------------------------------------------------
		//select hci command packet format:
		// ex. Get BD_ADDR   OpCode = 0x1009 payload length = 0
		//  HOST = 0 ;   //usb mode 
		//      Hci command packet = {0x09,0x10,0x00}
		//  HOST = 1 ;   //uart mode 
		//      Hci command packet = {0x01,0x09,0x10,0x00} , That byte0 is Command Header 
		//-------------------------------------------------------------
		HOST = 0 ;  

		//user define 
		if(pBaseDLLObject->BTMPAPI_BuildInterfaceVendor(
			&pBaseInterface,
			&BaseInterfaceModuleMemory,
			HOST,				//interface Type
			PortNumber,			//port Number ,Range 0~ 9
			(unsigned long)Baudrate,        //if is UART Interface , to setting the vaule    
			UserDefined_Open_Func,		//Vendor API
			UserDefined_Send_Func,		//Vendor API
			UserDefined_Recv_Func,		//Vendor API
			UserDefined_Close_Func,		//Vendor API  
			UserDefinedWaitMs	//Vendor API
			)!=0)
		{
			DBGPRINTF(">>Build interface Module Fail!!\n");
			goto exit;
		}

#endif
		/*
		>>Build Software Bluetooth Module  
		*/
		pBluetoothModule=&BluetoothModuleMemory;
		pBluetoothModule->BuildStatus=0;
		if (pBaseDLLObject->BTMPAPI_BuildBluetoothModule(pBluetoothModule,pBaseInterface,NULL,NULL,NULL) !=0)
		{
			DBGPRINTF(">>Build BT Module Fail!!\n");
			goto exit;
		}
				
		if (pBluetoothModule->BuildStatus ==0)
		{
			DBGPRINTF(">>Build BT Module status Fail!!\n");
			goto exit;
		}
		/*[2] 
				>>Device Open
				>>download Paatch Code
				>>initial device 
		*/
		if (pBaseInterface->Close(pBaseInterface)!=0)
		{
			DBGPRINTF(">>Device Open Fail!!\n");
			goto exit;

		}
		/* Wait 100 mSec*/
		pBaseInterface->WaitMs(pBaseInterface,100);

		if (pBaseInterface->Open(pBaseInterface)!=0)
		{
			DBGPRINTF(">>Open Device Fail...\n");
			goto exit;

		}
		DBGPRINTF(">>Open Device Success...\n");	
		pBaseInterface->WaitMs(pBaseInterface,100);

#ifdef AUTO_DOWN_LOAD_PATCH_CODE
		if (API_bt_Download_PatchCode() !=0)
		{    
			DBGPRINTF(">>RTKBT_OpenAdapter : Download patch code Fail...\n");
		}
		else
		{
			DBGPRINTF(">>RTKBT_OpenAdapter : Download patch code Success...\n");	
		}
#endif	


	API_bt_SetdefaultPowerTable();
	API_bt_SetDefaultTxDACTable();

	while (!bflag)
	{
		DBGPRINTF("\n");
		DBGPRINTF("*|--------------------- Test Item ------------------------|\n");
		DBGPRINTF(" 0:Exit \n 1:PKT TX \n 2:PKT RX \n 3:CON-TX \n 4:Hci Reset \n 5.Read efuse BD Addr \n 6.Write efuse BD Addr\n");
		DBGPRINTF(" 7:LE TX \n 8:LE RX \n 9:LE TX/RX Stop\n 10: Read Thermal\n");
		DBGPRINTF("*|--------------------------------------------------------|\n");
		DBGPRINTF("*-->Please inpunt Test Item:");
		scanf("%d",&item);
		switch (item)
		{
			case 3: BT_ConTx(pBluetoothModule); break;
			case 1: BT_PktTx(pBluetoothModule); break;
			case 2: BT_PktRx(pBluetoothModule); break;
			case 4: BT_HCIRST(pBluetoothModule); break;
			case 5: BT_ReadBDAddr(pBluetoothModule); break;
			case 6: BT_WriteBDAddr(pBluetoothModule); break;
			case 7: BT_LETx_RX_Start(pBluetoothModule,0);break;
            case 8: BT_LETx_RX_Start(pBluetoothModule,1);break;
		    case 9: BT_LETx_RX_Stop(pBluetoothModule);break;
			case 10: BT_ReadThermalMeter(pBluetoothModule, &thermal); break;
			case 0: bflag=1;	break;

			default:
				DBGPRINTF(">> Error Select Test Item...\n");	
			}	

        }
	//close
	if (pBaseInterface->Close(pBaseInterface) !=0)
		DBGPRINTF(">>Close Device Success..\n"); 
	else
		DBGPRINTF(">>Close Device Fail..\n");
exit:
	if (pBaseDLLObject != NULL)
	{
		ReleaseBTPMPDLLObject(pBaseDLLObject);
	}
	DBGPRINTF("============ MP Sample end========== \n");
	DBGPRINTF("please entry any key\n");
	getch();
	return 0;
}


