#if !defined(AFX_DBGFIELD_H__70118D93_3AAA_4C9F_85D7_3207370DCC8F__INCLUDED_)
#define AFX_DBGFIELD_H__70118D93_3AAA_4C9F_85D7_3207370DCC8F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DbgField.h : header file

typedef enum _DBG_COMMON_CMD_INDEX{
        DbgCommonMode,
        DbgCommonCommand,
        DbgCommonStatistics,
        DbgCommonChnlTxPower,
        DbgCommonMaxCmdIndex,
}DBG_COMMON_CMD_INDEX;

#define INC_CurrCMD         FieldDATA.CurrCMD = \
                            ((FieldDATA.CurrCMD+MaxCLIHistory+1)%MaxCLIHistory)
#define DEC_CurrCMD         FieldDATA.CurrCMD = \
                            ((FieldDATA.CurrCMD+MaxCLIHistory-1)%MaxCLIHistory)
#define INC_TotalCMD        if(FieldDATA.TotalCMD++ >= MaxCLIHistory)  \
                            FieldDATA.TotalCMD=MaxCLIHistory
#define INC_HistoryIndex    FieldDATA.HistoryIndex = \
                            ((FieldDATA.HistoryIndex+MaxCLIHistory+1)%MaxCLIHistory)
#define DEC_HistoryIndex    FieldDATA.HistoryIndex = \
                            ((FieldDATA.HistoryIndex+MaxCLIHistory-1)%MaxCLIHistory)
typedef struct _INTF_DBG_SEND{
    UINT    dbgOpCode;
    UINT    dbgLength;
    UINT    dbgCmdIndex;
    UINT    dbgArgc;
#define MaxDbgArgvNum       15
#define MaxDbgArgvLen       16
    char    dbgArgv[MaxDbgArgvNum*MaxDbgArgvLen];
} INTF_DBG_SEND;

typedef struct _INTF_DBG_RETURN{
    UINT    dbgOpCode;
    UINT    dbgStatus;
    UINT    dbgSegment;
    UINT    dbgLength;
    char    dbgRtnBuf[MaxDbgArgvNum*MaxDbgArgvLen];
} INTF_DBG_RETURN;

typedef struct _INTF_DBG{
    INTF_DBG_SEND       sendData;           //command data pass to dest
    INTF_DBG_RETURN     retnData;           //the returned data
} INTF_DBG;

typedef struct {
    CMD_ENTRY   *cmd;                       //pointer to the current command table
    DBG_OPCODE  dbg_mode;                   //current debug mode
    INTF_DBG    intfEntry;                  //current debug command entry
#define MaxCLIHistory       11				//can buffer MaxCLIHistory-1 commands
    CString     CLI_Buffer[MaxCLIHistory];  //command history
	CString		Prompt;                     //command prompt
    int         CurrCMD;                    //pointer to current command buffer
    int         TotalCMD;                   //total cmd in buffer
    int         HistoryIndex;               //pointer to the history buffer
}CLI_DATA;

extern CMD_ENTRY firmTable[];
extern CMD_ENTRY driverTable[];
extern CMD_ENTRY commonTable[];
extern CMD_ENTRY *cmd_table[];

#define MaxTokenNum		(MaxDbgArgvNum+1)

/////////////////////////////////////////////////////////////////////////////
// DbgField dialog

class DbgField : public CDialog
{
// Construction
public:
	DbgField(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(DbgField)
	enum { IDD = IDD_DBGFIELD_DIALOG };
	CEdit	m_CmdResult;
	CEdit	m_CmdLine;
	//}}AFX_DATA
    void ResultAppendText(LPCSTR pText);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(DbgField)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
    HICON m_hIcon;
    virtual BOOL OnInitDialog();
	void InitFieldData();
	BOOL ProcessInChar(UINT message, WPARAM inVal);
	CLI_DATA FieldDATA;
	BOOL parseEnterCMD();
	BOOL parseHelpCMD();
	BOOL parseSpaceCMD();
	void parseArrowKey(WPARAM inVal);
	void displayaAllCMDs(CMD_ENTRY *cmd);
	void switchDbgMode(DBG_OPCODE mode);
	BOOL dbgCommonCMD(CMD_ENTRY *cmd);
	void UIStatisticsDisp();
	void UIStatisticsClr();
	void UITxPowerDisplay();
	
	// Generated message map functions
	//{{AFX_MSG(DbgField)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DBGFIELD_H__70118D93_3AAA_4C9F_85D7_3207370DCC8F__INCLUDED_)
