// TX_PWR_MAP.cpp : implementation file
//

#include "stdafx.h"
#include "MP819xVC.h"
#include "TX_PWR_MAP.h"
#include "RtlFunc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// TX_PWR_MAP dialog


TX_PWR_MAP::TX_PWR_MAP(CWnd* pParent /*=NULL*/)
	: CDialog(TX_PWR_MAP::IDD, pParent)
{
	//{{AFX_DATA_INIT(TX_PWR_MAP)
	//}}AFX_DATA_INIT

	m_hIcon = AfxGetApp()->LoadIcon(IDI_REALTEK_ICO);
}


void TX_PWR_MAP::DoDataExchange(CDataExchange* pDX)
{
		
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(TX_PWR_MAP)
	DDX_Control(pDX, Power9g, m_Power9g);
	DDX_Control(pDX, Power9, m_Power9);
	DDX_Control(pDX, Power8g, m_Power8g);
	DDX_Control(pDX, Power8, m_Power8);
	DDX_Control(pDX, Power7g, m_Power7g);
	DDX_Control(pDX, Power7, m_Power7);
	DDX_Control(pDX, Power6g, m_Power6g);
	DDX_Control(pDX, Power6, m_Power6);
	DDX_Control(pDX, Power5g, m_Power5g);
	DDX_Control(pDX, Power5, m_Power5);
	DDX_Control(pDX, Power4g, m_Power4g);
	DDX_Control(pDX, Power4, m_Power4);
	DDX_Control(pDX, Power3g, m_Power3g);
	DDX_Control(pDX, Power3, m_Power3);
	DDX_Control(pDX, Power2g, m_Power2g);
	DDX_Control(pDX, Power2, m_Power2);
	DDX_Control(pDX, Power1g, m_Power1g);
	DDX_Control(pDX, Power14g, m_Power14g);
	DDX_Control(pDX, Power14, m_Power14);
	DDX_Control(pDX, Power13g, m_Power13g);
	DDX_Control(pDX, Power13, m_Power13);
	DDX_Control(pDX, Power12g, m_Power12g);
	DDX_Control(pDX, Power12, m_Power12);
	DDX_Control(pDX, Power11g, m_Power11g);
	DDX_Control(pDX, Power11, m_Power11);
	DDX_Control(pDX, Power10g, m_Power10g);
	DDX_Control(pDX, Power10, m_Power10);
	DDX_Control(pDX, Power1, m_Power1);
	DDX_Control(pDX, IDC_STATIC_RFATxPower, m_RF_TxPower_Static);
	DDX_Control(pDX, IDC_Restore, m_Restore);
	DDX_Control(pDX, IDC_Recover, m_Recover);
	DDX_Control(pDX, ID_Save, m_Save);
	DDX_Control(pDX, ID_Exit, m_Exit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(TX_PWR_MAP, CDialog)
	//{{AFX_MSG_MAP(TX_PWR_MAP)
	ON_BN_CLICKED(ID_Exit, OnExit)
	ON_BN_CLICKED(ID_Save, OnSave)
	ON_BN_CLICKED(IDC_Recover, OnRecover)
	ON_BN_CLICKED(IDC_Restore, OnRestore)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TX_PWR_MAP message handlers
BOOL TX_PWR_MAP::OnInitDialog() 
{
	int		i;

	CDialog::OnInitDialog();
	SetIcon(m_hIcon, FALSE);

	//PrintMsg(TEXT("===>OnInititDialog Tx Power Map!!\n" ));
	
	if(Adapter.EEType == EEPROM_93C46 || Adapter.EEType == EEPROM_BOOT_EFUSE)
		m_RF_TxPower_Static.ShowWindow(FALSE);
	else if(Adapter.EEType == EEPROM_93C56)
	{
		if(RfMode == RF_2T4R)
			m_RF_TxPower_Static.SetWindowText("RF-A Tx Power Level");
		else if(RfMode == RF_1T2R)
			m_RF_TxPower_Static.SetWindowText("RF-C Tx Power Level");
		m_RF_TxPower_Static.ShowWindow(TRUE);
		DisableControl();
	}
	
	for(i = 0; i < 14; i ++)
	{
		pm_CCK[i] = (CEdit *)GetDlgItem(Power1 + i);
		pm_OFDM24G[i] = (CEdit *)GetDlgItem(Power1g + i);		
	}

	//for(i = 0; i < 46; i ++)
	//	pm_OFDM_A[i] =  (CEdit *)GetDlgItem(Power26 + i);

	//cosa ShowTxPowerMap(CurrentChnlTxPowers);
	
	//PrintMsg(TEXT("<===OnInititDialog Tx Power Map!!\n" ));
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void TX_PWR_MAP::OnExit() 
{
	EndDialog(TRUE);	
}

void TX_PWR_MAP::OnSave() 
{
	int 		i, j, TxLen;
	UCHAR 	CurByte;
	TCHAR 	strTxBuf[4], strBuf[100];
	BYTE 	tmpTxPowers[TX_PWR_NUM];

	if(MessageBox(TEXT("Save to Map ?"),TEXT("Realtek"),MB_ICONQUESTION|MB_YESNO)!=IDYES)
		return;

	//PrintMsg(TEXT("===>Save Tx Power Map!!\n" ));
	
	for( i = 0; i < 14; i++)
	{
		// CCK
		TxLen = pm_CCK[i]->GetWindowText(strTxBuf, 3);
		if(!CheckAdd(strTxBuf,2) || TxLen > 2 || TxLen == 0)
		{
			_stprintf(strBuf, TEXT("CCK %d Tx Power Wrong Value !"), i);
			ErrMsgBox(strBuf);
			return;
		}

		CurByte = 0;
		for (j = 0; j < TxLen; j ++)
		{
			CurByte += Asc2Hex(strTxBuf[j]);
			if (j != TxLen-1)
				CurByte <<= 4;
		}
		
		tmpTxPowers[i] = CurByte;

		// OFDM 2.4G
		TxLen = pm_OFDM24G[i]->GetWindowText(strTxBuf, 3);
		if(!CheckAdd(strTxBuf,2) || TxLen > 2 || TxLen == 0)
		{
			_stprintf(strBuf, TEXT("OFDM G %d Tx Power Wrong Value !"), i);
			ErrMsgBox(strBuf);
			return;
		}
		
		CurByte = 0;
		for (j = 0; j < TxLen; j ++)
		{
			CurByte += Asc2Hex(strTxBuf[j]);
			if (j != TxLen-1)
				CurByte <<=4;
		}
		
		tmpTxPowers[14 + i] = CurByte;
	} 

	// OFDM A
	//for( i = 0; i < 46; i++)
	//{
	//	
	//	TxLen = pm_OFDM_A[i]->GetWindowText(strTxBuf, 3);
	//	if(!CheckAdd(strTxBuf,2) || TxLen > 2 || TxLen == 0)
	//	{
	//		_stprintf(strBuf, TEXT("OFDM A %d Tx Power Wrong Value !"), i);
	//		ErrMsgBox(strBuf);
	//		return;
	//	}
    //
	//	CurByte = 0;
	//	for (j = 0; j < TxLen; j ++)
	//	{
	//		CurByte += Asc2Hex(strTxBuf[j]);
	//		if (j != TxLen-1)
	//			CurByte <<=4;
	//	}
	//	
	//	tmpTxPowers[14 + i] = CurByte;
	//}

	//memcpy(CurrentChnlTxPowers, tmpTxPowers, TX_PWR_NUM);

	MessageBox("Save MAP OK","Tx Power Map");
	
	//PrintMsg(TEXT("<===Save Tx Power Map!!\n" ));

	OnExit();
	
}

VOID
TX_PWR_MAP::
ErrMsgBox(
	LPCTSTR		msg
	)
{
	MessageBox(
			msg,                                   
			TEXT("Realtek"),
			MB_OK|MB_ICONERROR|MB_SETFOREGROUND
			);
}

void TX_PWR_MAP::OnRecover() 
{	
	//ShowTxPowerMap(CurrentChnlTxPowers);
	MessageBox("Recover OK","Tx Power Map");
}

void TX_PWR_MAP::OnRestore() 
{
	BOOL 	bResult;
	BYTE 	tmpTxPowers[TX_PWR_NUM];

	//PrintMsg(TEXT("===>Read Tx Power From EEprom !!\n" ));
		
	bResult = ReadPowerControl(
				(LPADAPTER)(Adapter.hFile),
				tmpTxPowers, 
				TX_PWR_NUM
				);

	if(!bResult)
	{
		//PrintMsg(TEXT("!!!Read Tx Power From EEprom Error !!\n" ));
		ErrMsgBox(TEXT("Fail to Read Tx Power From EEprom !!" ));
		return;
	}

	ShowTxPowerMap(tmpTxPowers);
	
	MessageBox("Restore OK","Tx Power Map");
	
	//PrintMsg(TEXT("<===Read Tx Power From EEprom OK !!\n" ));
}

VOID
TX_PWR_MAP::
ShowTxPowerMap(
		IN	BYTE 		*TxPowers
		)
{
	int 		i;
	TCHAR 	strBuf[4];
	
	for(i = 0; i < 14; i ++)
	{
		_stprintf(strBuf, TEXT("%02X"), TxPowers[i]);
		pm_CCK[i]->SetWindowText(strBuf);
              if (Adapter.HardwareId == HID_8192U)
		{
			if ( (i != 0) &&( i != 6) &&( i != 12))
			{
			 	pm_CCK[i]->EnableWindow(FALSE);
   			}	
		}
		_stprintf(strBuf, TEXT("%02X"), TxPowers[14+i]);
		pm_OFDM24G[i]->SetWindowText(strBuf);
		if (Adapter.HardwareId == HID_8192U)
		{
			if ((i != 0) &&( i != 6) &&( i != 12) )
			{
			 	pm_OFDM24G[i]->EnableWindow(FALSE);
   			}	
		}
	}

	//for(i = 0; i < 46; i++)
	//{
	//	_stprintf(strBuf, TEXT("%02X"), TxPowers[14 + i]);
	//	pm_OFDM_A[i]->SetWindowText(strBuf);
	//}
}


void TX_PWR_MAP::DisableControl(
		) 
{
	m_Save.EnableWindow(FALSE);
	m_Recover.EnableWindow(FALSE);
	m_Restore.EnableWindow(FALSE);
	
	m_Power1g.EnableWindow(FALSE);
	m_Power2g.EnableWindow(FALSE);
	m_Power3g.EnableWindow(FALSE);
	m_Power4g.EnableWindow(FALSE);
	m_Power5g.EnableWindow(FALSE);
	m_Power6g.EnableWindow(FALSE);
	m_Power7g.EnableWindow(FALSE);
	m_Power8g.EnableWindow(FALSE);
	m_Power9g.EnableWindow(FALSE);
	m_Power10g.EnableWindow(FALSE);
	m_Power11g.EnableWindow(FALSE);
	m_Power12g.EnableWindow(FALSE);
	m_Power13g.EnableWindow(FALSE);
	m_Power14g.EnableWindow(FALSE);
	
	m_Power1.EnableWindow(FALSE);
	m_Power2.EnableWindow(FALSE);
	m_Power3.EnableWindow(FALSE);
	m_Power4.EnableWindow(FALSE);
	m_Power5.EnableWindow(FALSE);
	m_Power6.EnableWindow(FALSE);
	m_Power7.EnableWindow(FALSE);
	m_Power8.EnableWindow(FALSE);
	m_Power9.EnableWindow(FALSE);
	m_Power10.EnableWindow(FALSE);
	m_Power11.EnableWindow(FALSE);
	m_Power12.EnableWindow(FALSE);
	m_Power13.EnableWindow(FALSE);
	m_Power14.EnableWindow(FALSE);
}
